.model small
.stack 100h
.data
; 'Intro'Text
intro   db  0Dh,0Ah,'WordOut: Zeicheneingabe, Ausgabe Echo, Hexdump (Abbruch bei ESC)'
        db  0Dh,0Ah,'Geben Sie Zeichen (Buchstaben oder Ziffern) ein: $'

.code
; ----------------
;  Hauptprogramm:
; ----------------
start:  mov     ax,@data
        mov     ds,ax       ; DS zeigt auf das Datensegment

; Ausgabe vom 'Intro'Text
again:  mov     ah,9h       ; Fkt. 9: Stringausgabe bis $
        mov     dx,Offset intro
        int     21h

; Eingabe und Echo von drei Zeichen
        call    c1_in       ; Eingabe des ersten Zeichens
        mov     dh,al       ; In Register DH sichern
        call    c_in        ; Eingabe des zweiten Zeichens
        mov     bh,al       ; In Register BH sichern
        mov     ah,2h       ; Fkt. 2: Einzelzeichen Ausgabe
        mov     dl,020h     ; Leerzeichen in DL und
        int     21h         ; ausgeben
        call    c_in        ; Eingabe des dritten Zeichens
        mov     bl,al       ; In Register BL sichern
; Umwandlung Ausgabe der drei Zeichencodes als HEX-Zahlen
        call    n_line      ; Zeile weiterschalten und Cursor auf Zeilenanfang stellen(ah 2h)
        mov     dl,dh       ; Erstes Zeichen in DL
        call    b_out       ; Nur erstes Zeichen Umwandeln und Ausgeben
        mov     ah,2h       ; Fkt. 2: Einzelzeichen Ausgabe
        mov     dl,020h     ; Leerzeichen in DL und
        int     21h         ; ausgeben
        call    w_out       ; Die verbleibenden beiden Zeichen Umwandeln und Ausgeben
        jmp     again       ; Zeichen Ein/Ausgabe wiederholen (Bis ESC)
; -----------------
;  Unterprogramme:
; -----------------

; Erstes Zeichen Ein/Ausgabe, Programmverzweigung steuern, Abbruch?
c1_in:  mov     ah,8h       ; Fkt. 8: Tastatur-Zeicheneingabe ohne Echo
        int     21h         ; eingegebenes Zeichen in Register AL
        cmp     al,01Bh     ; Wenn ESC
        jz      pEnde       ; Programmm abbrechen
        mov     ah,2h       ; Fkt. 2: Einzelzeichen Ausgabe
        mov     dl,al       ; Eingabezeichen in DL und
        int     21h         ; ausgeben
        mov     ah,2h
        mov     dl,020h     ; Leerzeichen in DL und
        int     21h         ; ausgeben
        ret

; Weitere Zeichen Ein/Ausgabe
c_in:   mov     ah,1h       ; Fkt. 1: Tastatur-Zeicheneingabe mit Echo
        int     21h         ; eingegebenes Zeichen in Register AL
        ret

; Inhalt von DL nach HEX, und gibt Zeichencode aus (z_out)
b_out:  mov     cl,dl       ; Inhalt von DL wird nach CL esichert
        shr     dl,1        ; Oberes Nibble - Bitmuster 4 mal nach rechts shiften
        shr     dl,1        ; dabei 0000 nachziehen
        shr     dl,1
        shr     dl,1
        call    z_out       ; Inhalt DL in ASCII-Z. wandeln u. ausgeben
        mov     dl,cl       ; Zeichen wird aus CL wiederhergestellt
        and     dl,00001111b   ; Unteres Nibble - Obere 4 Bit loeschen mit Maske 0Fh,
        call    z_out       ; Inhalt DL in ASCII-Z. wandeln u. ausgeben
        ret

; Word-Operanden werden umgewandelt/ausgegeben durch zweifaches Aufrufen von b_out
w_out:  mov     dl,bh       ; Zweite Zeichen in DL
        call    b_out
        mov     ah,2h       ; Fkt. 2: Einzelzeichen Ausgabe
        mov     dl,020h     ; Leerzeichen in DL und
        int     21h         ; ausgeben
        mov     dl,bl       ; Dritte Zeichen in DL
        call    b_out
        ret

; Wandlung Nibble > Hexzeichen (ASCII codiert)
z_out:  cmp     dl,10       ; wenn (AL -10) < 0 dann CF<- 1 (Unterlauf)
        jc      ziff        ; wenn CF=1 , dann Ziffer sonst Buchstabe
        add     dl,07h      ; 37h addieren (Bsp: 07h + 0Ah + 30h = 'A' )
ziff:   add     dl,030h     ; 30h addieren (Bsp: 04h + 30h = '4' )
        mov     ah,2h       ; Fkt. 2: Einzelzeichen Ausgabe
        int     21h
        ret

; In neue Zeile schalten
n_line: mov     ah,2h       ; Fkt. 2: Einzelzeichen Ausgabe
        mov     dl,0Ah      ; LF in DL
        int     21h
        mov     ah,2h
        mov     dl,0Dh      ; CR in DL
        int     21h
        ret

; Programm beenden
pEnde:  mov     ah,4Ch      ; DOS Funktion Programmende
        int     21h         ; Programm beenden

        end     start
